<html>
<head>
<title>OgreMaterial.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMaterial.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMaterial_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _Material_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _Material_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreBlendMode_8h.html">OgreBlendMode.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041     <span class="comment">// Forward declaration</span>
<a name="l00042"></a>00042     <span class="keyword">class </span>MaterialPtr;
<a name="l00043"></a>00043     <span class="keyword">class </span>LodStrategy;
<a name="l00044"></a>00044 
<a name="l00088"></a><a class="code" href="classOgre_1_1Material.html">00088</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>
<a name="l00089"></a>00089     {
<a name="l00090"></a><a class="code" href="classOgre_1_1Material.html#a284464b0561a6f2915f04b0245b987f0">00090</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>;
<a name="l00091"></a><a class="code" href="classOgre_1_1Material.html#a00bfe1380be4c044551121bbd7fb8359">00091</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MaterialManager.html" title="Class for managing Material settings for Ogre.">MaterialManager</a>;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     <span class="keyword">public</span>:
<a name="l00095"></a><a class="code" href="classOgre_1_1Material.html#a4c0945a06c098b9b1d366d9d3ba857fe">00095</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Real&gt;::type</a> <a class="code" href="classOgre_1_1Material.html#a4c0945a06c098b9b1d366d9d3ba857fe" title="distance list used to specify LOD">LodValueList</a>;
<a name="l00096"></a><a class="code" href="classOgre_1_1Material.html#a02b750ad4a1d2c0aa92cfb7039cd7f95">00096</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;LodValueList&gt;</a> <a class="code" href="classOgre_1_1Material.html#a02b750ad4a1d2c0aa92cfb7039cd7f95">LodValueIterator</a>;
<a name="l00097"></a>00097     <span class="keyword">protected</span>:
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00102"></a>00102         <span class="keywordtype">void</span> applyDefaults(<span class="keywordtype">void</span>);
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="classOgre_1_1Material.html#afdf9a8d8a4b01de34a66266e0769b5e6">00104</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Technique*&gt;::type</a> <a class="code" href="classOgre_1_1Material.html#afdf9a8d8a4b01de34a66266e0769b5e6">Techniques</a>;
<a name="l00106"></a><a class="code" href="classOgre_1_1Material.html#ae158fb2cce67f89ba7ee840bb8ef23c2">00106</a>         <a class="code" href="classOgre_1_1Material.html#afdf9a8d8a4b01de34a66266e0769b5e6">Techniques</a> <a class="code" href="classOgre_1_1Material.html#ae158fb2cce67f89ba7ee840bb8ef23c2" title="All techniques, supported and unsupported.">mTechniques</a>;
<a name="l00108"></a><a class="code" href="classOgre_1_1Material.html#a70c34733a2a03532e537c12478532267">00108</a>         <a class="code" href="classOgre_1_1Material.html#afdf9a8d8a4b01de34a66266e0769b5e6">Techniques</a> <a class="code" href="classOgre_1_1Material.html#a70c34733a2a03532e537c12478532267" title="Supported techniques of any sort.">mSupportedTechniques</a>;
<a name="l00109"></a><a class="code" href="classOgre_1_1Material.html#a26ecf1ee6d15c7132773634a9760f4f8">00109</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;unsigned short, Technique*&gt;::type</a> <a class="code" href="classOgre_1_1Material.html#a26ecf1ee6d15c7132773634a9760f4f8">LodTechniques</a>;
<a name="l00110"></a><a class="code" href="classOgre_1_1Material.html#a0872ad5223a334fc9f3a0e2053d92494">00110</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;unsigned short, LodTechniques*&gt;::type</a> <a class="code" href="classOgre_1_1Material.html#a0872ad5223a334fc9f3a0e2053d92494">BestTechniquesBySchemeList</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1Material.html#abf8912f7095a732da38674eb70969788">00115</a>         <a class="code" href="classOgre_1_1Material.html#a0872ad5223a334fc9f3a0e2053d92494">BestTechniquesBySchemeList</a> <a class="code" href="classOgre_1_1Material.html#abf8912f7095a732da38674eb70969788" title="Map of scheme -&gt; list of LOD techniques.">mBestTechniquesBySchemeList</a>;
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classOgre_1_1Material.html#a24cead398bd291dcaa531b3ec288b58f">00117</a>         <a class="code" href="classOgre_1_1Material.html#a4c0945a06c098b9b1d366d9d3ba857fe" title="distance list used to specify LOD">LodValueList</a> <a class="code" href="classOgre_1_1Material.html#a24cead398bd291dcaa531b3ec288b58f">mUserLodValues</a>;
<a name="l00118"></a><a class="code" href="classOgre_1_1Material.html#aeb3895b9c7613241799ccd9ec1d658a5">00118</a>         <a class="code" href="classOgre_1_1Material.html#a4c0945a06c098b9b1d366d9d3ba857fe" title="distance list used to specify LOD">LodValueList</a> <a class="code" href="classOgre_1_1Material.html#aeb3895b9c7613241799ccd9ec1d658a5">mLodValues</a>;
<a name="l00119"></a><a class="code" href="classOgre_1_1Material.html#a0960b6028125b936aacd76c558ec477d">00119</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a> *<a class="code" href="classOgre_1_1Material.html#a0960b6028125b936aacd76c558ec477d">mLodStrategy</a>;
<a name="l00120"></a><a class="code" href="classOgre_1_1Material.html#aa1667bc10463df4c60d3ca09d5250a26">00120</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Material.html#aa1667bc10463df4c60d3ca09d5250a26">mReceiveShadows</a>;
<a name="l00121"></a><a class="code" href="classOgre_1_1Material.html#aecf730df2c994846c06763f4eb163361">00121</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Material.html#aecf730df2c994846c06763f4eb163361">mTransparencyCastsShadows</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1Material.html#a9a746dac3104b618973e9cb090752376">00123</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Material.html#a9a746dac3104b618973e9cb090752376" title="Does this material require compilation?">mCompilationRequired</a>;
<a name="l00125"></a><a class="code" href="classOgre_1_1Material.html#a97d8c59610740bad4047c69c3986782d">00125</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Material.html#a97d8c59610740bad4047c69c3986782d" title="Text description of why any techniques are not supported.">mUnsupportedReasons</a>;
<a name="l00126"></a>00126 
<a name="l00128"></a>00128         <span class="keywordtype">void</span> insertSupportedTechnique(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* t);
<a name="l00129"></a>00129 
<a name="l00132"></a>00132         <span class="keywordtype">void</span> clearBestTechniqueList(<span class="keywordtype">void</span>);
<a name="l00133"></a>00133 
<a name="l00136"></a>00136         <span class="keywordtype">void</span> prepareImpl(<span class="keywordtype">void</span>);
<a name="l00137"></a>00137 
<a name="l00140"></a>00140         <span class="keywordtype">void</span> unprepareImpl(<span class="keywordtype">void</span>);
<a name="l00141"></a>00141 
<a name="l00144"></a>00144         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00145"></a>00145 
<a name="l00150"></a>00150         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00152"></a><a class="code" href="classOgre_1_1Material.html#a6b7f88e5dc87f595e875b795014b693c">00152</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Material.html#a6b7f88e5dc87f595e875b795014b693c">calculateSize</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; } <span class="comment">// TODO </span>
<a name="l00153"></a>00153     <span class="keyword">public</span>:
<a name="l00154"></a>00154 
<a name="l00157"></a>00157         <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00158"></a>00158             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160         ~<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>();
<a name="l00163"></a>00163         <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>&amp; operator=( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>&amp; rhs );
<a name="l00164"></a>00164 
<a name="l00168"></a>00168         <span class="keywordtype">bool</span> isTransparent(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00169"></a>00169 
<a name="l00183"></a><a class="code" href="classOgre_1_1Material.html#abe6a4371ce72c7bf1cf5a0c2e9259815">00183</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Material.html#abe6a4371ce72c7bf1cf5a0c2e9259815" title="Sets whether objects using this material will receive shadows.">setReceiveShadows</a>(<span class="keywordtype">bool</span> enabled) { mReceiveShadows = enabled; }
<a name="l00185"></a><a class="code" href="classOgre_1_1Material.html#a5cdf34620f4cde27d69dda252081f18c">00185</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Material.html#a5cdf34620f4cde27d69dda252081f18c" title="Returns whether or not objects using this material will receive shadows.">getReceiveShadows</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mReceiveShadows; }
<a name="l00186"></a>00186 
<a name="l00195"></a><a class="code" href="classOgre_1_1Material.html#a5552baf6c922eb48a981f7c51aadc5e2">00195</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Material.html#a5552baf6c922eb48a981f7c51aadc5e2" title="Sets whether objects using this material be classified as opaque to the shadow caster system...">setTransparencyCastsShadows</a>(<span class="keywordtype">bool</span> enabled) { mTransparencyCastsShadows = enabled; }
<a name="l00197"></a><a class="code" href="classOgre_1_1Material.html#aae8ee2517456bdd4b01217e40045fd7c">00197</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Material.html#aae8ee2517456bdd4b01217e40045fd7c" title="Returns whether or not objects using this material be classified as opaque to the shadow caster syste...">getTransparencyCastsShadows</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTransparencyCastsShadows; }
<a name="l00198"></a>00198 
<a name="l00213"></a>00213         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* createTechnique(<span class="keywordtype">void</span>);
<a name="l00215"></a>00215         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getTechnique(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00219"></a>00219         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getTechnique(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00221"></a>00221         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumTechniques(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00223"></a>00223         <span class="keywordtype">void</span> removeTechnique(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);     
<a name="l00225"></a>00225         <span class="keywordtype">void</span> removeAllTechniques(<span class="keywordtype">void</span>);
<a name="l00226"></a><a class="code" href="classOgre_1_1Material.html#a4969168248bff6aea70eafcf75497689">00226</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;Techniques&gt;</a> <a class="code" href="classOgre_1_1Material.html#a4969168248bff6aea70eafcf75497689">TechniqueIterator</a>;
<a name="l00228"></a>00228         <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">TechniqueIterator</a> getTechniqueIterator(<span class="keywordtype">void</span>);
<a name="l00235"></a>00235         <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">TechniqueIterator</a> getSupportedTechniqueIterator(<span class="keywordtype">void</span>);
<a name="l00236"></a>00236         
<a name="l00238"></a>00238         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getSupportedTechnique(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00240"></a>00240         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumSupportedTechniques(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00242"></a><a class="code" href="classOgre_1_1Material.html#a9d89348c66c6d66bd3a25764d6e8888c">00242</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1Material.html#a9d89348c66c6d66bd3a25764d6e8888c" title="Gets a string explaining why any techniques are not supported.">getUnsupportedTechniquesExplanation</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUnsupportedReasons; }
<a name="l00243"></a>00243 
<a name="l00249"></a>00249         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumLodLevels(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> schemeIndex) <span class="keyword">const</span>;
<a name="l00255"></a>00255         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumLodLevels(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; schemeName) <span class="keyword">const</span>;
<a name="l00256"></a>00256 
<a name="l00272"></a>00272         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getBestTechnique(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> lodIndex = 0, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend = 0);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00280"></a>00280         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> clone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newName, <span class="keywordtype">bool</span> changeGroup = <span class="keyword">false</span>, 
<a name="l00281"></a>00281             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newGroup = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>) <span class="keyword">const</span>;
<a name="l00282"></a>00282 
<a name="l00287"></a>00287         <span class="keywordtype">void</span> copyDetailsTo(<a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat) <span class="keyword">const</span>;
<a name="l00288"></a>00288 
<a name="l00304"></a>00304         <span class="keywordtype">void</span> compile(<span class="keywordtype">bool</span> autoManageTextureUnits = <span class="keyword">true</span>);
<a name="l00305"></a>00305 
<a name="l00306"></a>00306         <span class="comment">// -------------------------------------------------------------------------------</span>
<a name="l00307"></a>00307         <span class="comment">// The following methods are to make migration from previous versions simpler</span>
<a name="l00308"></a>00308         <span class="comment">// and to make code easier to write when dealing with simple materials</span>
<a name="l00309"></a>00309         <span class="comment">// They set the properties which have been moved to Pass for all Techniques and all Passes</span>
<a name="l00310"></a>00310 
<a name="l00320"></a>00320         <span class="keywordtype">void</span> setPointSize(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> ps);
<a name="l00321"></a>00321 
<a name="l00331"></a>00331         <span class="keywordtype">void</span> setAmbient(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue);
<a name="l00332"></a>00332 
<a name="l00342"></a>00342         <span class="keywordtype">void</span> setAmbient(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; ambient);
<a name="l00343"></a>00343 
<a name="l00353"></a>00353         <span class="keywordtype">void</span> setDiffuse(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> alpha);
<a name="l00354"></a>00354 
<a name="l00364"></a>00364         <span class="keywordtype">void</span> setDiffuse(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; diffuse);
<a name="l00365"></a>00365 
<a name="l00375"></a>00375         <span class="keywordtype">void</span> setSpecular(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> alpha);
<a name="l00376"></a>00376 
<a name="l00386"></a>00386         <span class="keywordtype">void</span> setSpecular(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; specular);
<a name="l00387"></a>00387 
<a name="l00397"></a>00397         <span class="keywordtype">void</span> setShininess(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> val);
<a name="l00398"></a>00398 
<a name="l00408"></a>00408         <span class="keywordtype">void</span> setSelfIllumination(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue);
<a name="l00409"></a>00409 
<a name="l00419"></a>00419         <span class="keywordtype">void</span> setSelfIllumination(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; selfIllum);
<a name="l00420"></a>00420 
<a name="l00430"></a>00430         <span class="keywordtype">void</span> setDepthCheckEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00431"></a>00431 
<a name="l00441"></a>00441         <span class="keywordtype">void</span> setDepthWriteEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00442"></a>00442 
<a name="l00452"></a>00452         <span class="keywordtype">void</span> setDepthFunction( <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func );
<a name="l00453"></a>00453 
<a name="l00463"></a>00463         <span class="keywordtype">void</span> setColourWriteEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00464"></a>00464 
<a name="l00474"></a>00474         <span class="keywordtype">void</span> setCullingMode( <a class="code" href="group__General.html#gac173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mode );
<a name="l00475"></a>00475 
<a name="l00485"></a>00485         <span class="keywordtype">void</span> setManualCullingMode( <a class="code" href="group__General.html#ga07ec94cf178172a6778223e6f70f23fc" title="Manual culling modes based on vertex normals.">ManualCullingMode</a> mode );
<a name="l00486"></a>00486 
<a name="l00496"></a>00496         <span class="keywordtype">void</span> setLightingEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00497"></a>00497 
<a name="l00507"></a>00507         <span class="keywordtype">void</span> setShadingMode( <a class="code" href="group__General.html#ga7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> mode );
<a name="l00508"></a>00508 
<a name="l00518"></a>00518         <span class="keywordtype">void</span> setFog(
<a name="l00519"></a>00519             <span class="keywordtype">bool</span> overrideScene,
<a name="l00520"></a>00520             <a class="code" href="group__General.html#ga83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> mode = <a class="code" href="group__General.html#gga83edeb2e5d33a3ca8f15834ba40020baab7793a21880052c0214d4cc040992310" title="No fog. Duh.">FOG_NONE</a>,
<a name="l00521"></a>00521             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a>,
<a name="l00522"></a>00522             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> expDensity = 0.001, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearStart = 0.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearEnd = 1.0 );
<a name="l00523"></a>00523 
<a name="l00533"></a>00533         <span class="keywordtype">void</span> setDepthBias(<span class="keywordtype">float</span> constantBias, <span class="keywordtype">float</span> slopeScaleBias);
<a name="l00534"></a>00534 
<a name="l00543"></a>00543         <span class="keywordtype">void</span> setTextureFiltering(<a class="code" href="group__General.html#ga21a0186392e9c9ce16d29c5568a773c5" title="High-level filtering options providing shortcuts to settings the minification, magnification and mip ...">TextureFilterOptions</a> filterType);
<a name="l00552"></a>00552         <span class="keywordtype">void</span> setTextureAnisotropy(<span class="keywordtype">int</span> maxAniso);
<a name="l00553"></a>00553 
<a name="l00563"></a>00563         <span class="keywordtype">void</span> setSceneBlending( <span class="keyword">const</span> <a class="code" href="group__Materials.html#gac46c60cf6e5c199220e3b8f26570cb9a" title="Types of blending that you can specify between an object and the existing contents of the scene...">SceneBlendType</a> sbt );
<a name="l00564"></a>00564 
<a name="l00574"></a>00574         <span class="keywordtype">void</span> setSeparateSceneBlending( <span class="keyword">const</span> <a class="code" href="group__Materials.html#gac46c60cf6e5c199220e3b8f26570cb9a" title="Types of blending that you can specify between an object and the existing contents of the scene...">SceneBlendType</a> sbt, <span class="keyword">const</span> <a class="code" href="group__Materials.html#gac46c60cf6e5c199220e3b8f26570cb9a" title="Types of blending that you can specify between an object and the existing contents of the scene...">SceneBlendType</a> sbta );
<a name="l00575"></a>00575 
<a name="l00585"></a>00585         <span class="keywordtype">void</span> setSceneBlending( <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor);
<a name="l00586"></a>00586 
<a name="l00596"></a>00596         <span class="keywordtype">void</span> setSeparateSceneBlending( <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactorAlpha, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactorAlpha);
<a name="l00597"></a>00597 
<a name="l00599"></a>00599         <span class="keywordtype">void</span> _notifyNeedsRecompile(<span class="keywordtype">void</span>);
<a name="l00600"></a>00600 
<a name="l00615"></a>00615         <span class="keywordtype">void</span> setLodLevels(<span class="keyword">const</span> LodValueList&amp; lodValues);
<a name="l00616"></a>00616 
<a name="l00624"></a>00624         LodValueIterator getLodValueIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00625"></a>00625 
<a name="l00633"></a>00633         LodValueIterator getUserLodValueIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00634"></a>00634 
<a name="l00640"></a>00640         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getLodIndex(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value) <span class="keyword">const</span>;
<a name="l00641"></a>00641 
<a name="l00643"></a>00643         <span class="keyword">const</span> <a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a> *getLodStrategy() <span class="keyword">const</span>;
<a name="l00645"></a>00645         <span class="keywordtype">void</span> setLodStrategy(<a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a> *lodStrategy);
<a name="l00646"></a>00646 
<a name="l00649"></a><a class="code" href="classOgre_1_1Material.html#a340e9c6140a5b0f3467596712aa122a9">00649</a>         <span class="keywordtype">void</span> touch(<span class="keywordtype">void</span>) 
<a name="l00650"></a>00650         { 
<a name="l00651"></a>00651             <span class="keywordflow">if</span> (mCompilationRequired) 
<a name="l00652"></a>00652                 compile();
<a name="l00653"></a>00653             <span class="comment">// call superclass</span>
<a name="l00654"></a>00654             <a class="code" href="classOgre_1_1Resource.html#ae229b1f58092109adef55bfc6f864d79" title="&#39;Touches&#39; the resource to indicate it has been used.">Resource::touch</a>();
<a name="l00655"></a>00655         }
<a name="l00656"></a>00656         
<a name="l00668"></a>00668         <span class="keywordtype">bool</span> applyTextureAliases(<span class="keyword">const</span> <a class="code" href="group__General.html#ga20898062bd79359acd1137276d9b0e37" title="Alias / Texture name pair (first = alias, second = texture name)">AliasTextureNamePairList</a>&amp; aliasList, <span class="keyword">const</span> <span class="keywordtype">bool</span> apply = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00669"></a>00669 
<a name="l00673"></a><a class="code" href="classOgre_1_1Material.html#a36da1bc08aaf6af5d410e505d5676d4f">00673</a>         <span class="keywordtype">bool</span> getCompilationRequired()<span class="keyword"> const</span>
<a name="l00674"></a>00674 <span class="keyword">        </span>{
<a name="l00675"></a>00675             <span class="keywordflow">return</span> mCompilationRequired;
<a name="l00676"></a>00676         }
<a name="l00677"></a>00677 
<a name="l00678"></a>00678 
<a name="l00679"></a>00679     };
<a name="l00680"></a>00680 
<a name="l00687"></a><a class="code" href="classOgre_1_1MaterialPtr.html">00687</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;Material&gt; 
<a name="l00688"></a>00688     {
<a name="l00689"></a>00689     <span class="keyword">public</span>:
<a name="l00690"></a><a class="code" href="classOgre_1_1MaterialPtr.html#a783b3718dc6d66583a7dac271530ad96">00690</a>         <a class="code" href="classOgre_1_1MaterialPtr.html#a783b3718dc6d66583a7dac271530ad96">MaterialPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>&gt;() {}
<a name="l00691"></a><a class="code" href="classOgre_1_1MaterialPtr.html#a576d942bf855439dd4940531dda534c2">00691</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1MaterialPtr.html#a576d942bf855439dd4940531dda534c2">MaterialPtr</a>(<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>&gt;(rep) {}
<a name="l00692"></a><a class="code" href="classOgre_1_1MaterialPtr.html#acbce2c39bc324169e24d4644478f69fd">00692</a>         <a class="code" href="classOgre_1_1MaterialPtr.html#acbce2c39bc324169e24d4644478f69fd">MaterialPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>&gt;(r) {} 
<a name="l00693"></a><a class="code" href="classOgre_1_1MaterialPtr.html#ab7770d65e35dba90fa79d86392dff6bc">00693</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>&gt;()
<a name="l00694"></a>00694         {
<a name="l00695"></a>00695             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00696"></a>00696             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00697"></a>00697             {
<a name="l00698"></a>00698                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00699"></a>00699                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00700"></a>00700                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00701"></a>00701                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00702"></a>00702                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00703"></a>00703                 {
<a name="l00704"></a>00704                     ++(*pUseCount);
<a name="l00705"></a>00705                 }
<a name="l00706"></a>00706             }
<a name="l00707"></a>00707         }
<a name="l00708"></a>00708 
<a name="l00710"></a><a class="code" href="classOgre_1_1MaterialPtr.html#a12aad74083bc28b076bb5922ce80f1d6">00710</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00711"></a>00711         {
<a name="l00712"></a>00712             <span class="keywordflow">if</span> (pRep == static_cast&lt;Material*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00713"></a>00713                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00714"></a>00714             release();
<a name="l00715"></a>00715             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00716"></a>00716             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00717"></a>00717             {
<a name="l00718"></a>00718                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00719"></a>00719                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00720"></a>00720                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00721"></a>00721                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00722"></a>00722                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00723"></a>00723                 {
<a name="l00724"></a>00724                     ++(*pUseCount);
<a name="l00725"></a>00725                 }
<a name="l00726"></a>00726             }
<a name="l00727"></a>00727             <span class="keywordflow">else</span>
<a name="l00728"></a>00728             {
<a name="l00729"></a>00729                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00730"></a>00730                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00731"></a>00731                 setNull();
<a name="l00732"></a>00732             }
<a name="l00733"></a>00733             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00734"></a>00734         }
<a name="l00735"></a>00735     };
<a name="l00739"></a>00739 } <span class="comment">//namespace </span>
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
